﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.UI;
using Telerik.WinControls;

namespace WindowsFormsApplication26
{
    public partial class Form1 : Form
    {
        List<RadElement> listOfItems = new List<RadElement>();

        public Form1()
        {
            InitializeComponent();

            this.radToolStripItem1.OverflowButton.DropDownOpened += new EventHandler(OverflowButton_DropDownOpened);

            this.radButtonElement4.Click += new EventHandler(newButton_Click);
            this.radButtonElement2.Click += new EventHandler(newButton2_Click);
            this.radCheckBoxElement1.ToggleStateChanged += new StateChangedEventHandler(newCheckElement_ToggleStateChanged);
        }

        void OverflowButton_DropDownOpened(object sender, EventArgs e)
        {
            RadDropDownMenu menu = this.radToolStripItem1.OverflowButton.DropDownMenu;

            RadMenuContentItem item = new RadMenuContentItem();
            item.ContentElement = new StackLayoutPanel();
            if (menu.Items[0] is RadMenuContentItem)
            {
                RadMenuContentItem oldItem = (RadMenuContentItem)menu.Items[0];
                for (int i = 0; i < oldItem.ContentElement.Children.Count; i++)
                {
                    switch (oldItem.ContentElement.Children[i].GetType().Name)
                    {
                        case "RadButtonElement":
                            RadButtonElement newButtonElement = new RadButtonElement();
                            newButtonElement.Text = ((RadButtonElement)oldItem.ContentElement.Children[i]).Text;
                            newButtonElement.Image = ((RadButtonElement)oldItem.ContentElement.Children[i]).Image;
                            if (newButtonElement.Text == "radButtonElement4")
                            {
                                newButtonElement.Click += new EventHandler(newButton_Click);
                            }
                            else
                            {
                                newButtonElement.Click += new EventHandler(newButton2_Click);
                            }
                            item.ContentElement.Children.Add(newButtonElement);
                            break;
                        case "RadCheckBoxElement":
                            RadCheckBoxElement newCheckElement = new RadCheckBoxElement();
                            newCheckElement.Text = ((RadCheckBoxElement)oldItem.ContentElement.Children[i]).Text;
                            newCheckElement.ToggleStateChanged += new StateChangedEventHandler(newCheckElement_ToggleStateChanged);
                            item.ContentElement.Children.Add(newCheckElement);
                            break;
                    }
                }

                menu.UseNewLayoutSystem = true;
                menu.Items.RemoveAt(0);
                menu.Items.Insert(0, item);
            }
        }

        void newCheckElement_ToggleStateChanged(object sender, StateChangedEventArgs args)
        {
            MessageBox.Show("StateChanged");
        }

        void newButton_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Button4");
        }

        void newButton2_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Others");
        }
    }
}
